#include <iostream>
#include <vector>
#include <string>
#include "algorithm"

using namespace std;

string int_to_string(int value) {
    string s;
    while (value > 0) {
        s.push_back('0' + value % 10);
        value /= 10;
    }
    if (s.empty()) {
        s.push_back('0');
    }
    reverse(s.begin(), s.end());
    return s;
}

long long string_to_long(string const &s, int skip = -1) {
    long long value = 0;
    for (unsigned int i = 0; i < s.size(); i++) {
        if (static_cast<int>(i) != skip) {
            value = value * 10 + s[i] - '0';
        }
    }
    return value;
}

long long with_sign(long long value, bool sign) {
    return sign ? value : -value;
}

int main() {

    int item;
    cin >> item;
    vector<int> items{item};
    vector<string> stritems{int_to_string(item)};
    vector<bool> ops{true};

    unsigned int n = stritems[0].size();
    char op;
    while (cin >> op >> item) {
        ops.push_back(op == '+');
        items.push_back(item);

        string stritem = int_to_string(item);
        stritems.push_back(stritem);
        n += stritem.size() + 1;
    }

    unsigned int nitem = 0, ni = 0, res = 0;
    long long diff = string_to_long(stritems[0], 0) - items[0];
    long long absres = 0;
    for (unsigned int i = 0; i < items.size(); i++) {
        absres += with_sign(items[i], ops[i]);
    }

    auto relax = [&diff, &res](long long change, int i) {
        if (change > diff) {
            res = i;
            diff = change;
        }
    };
    for (unsigned int i = 0; i < n; i++) {
        if (ni == stritems[nitem].size()) {
            long long change = with_sign(string_to_long(stritems[nitem] + stritems[nitem + 1]), ops[nitem]) -
                               with_sign(items[nitem], ops[nitem]) -
                               with_sign(items[nitem + 1], ops[nitem + 1]);
            relax(change, i);
            nitem++;
            ni = 0;
            continue;
        }
        long long change = with_sign(string_to_long(stritems[nitem], ni) - items[nitem], ops[nitem]);
        relax(change, i);
        ni++;
    }

    cout << absres + diff << '\n';

}