// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

bool is_digit(char c) {
	return '0' <= c && c <= '9';
}

void solve() {
	string s;
	cin >> s;

	ll sum = 0;
	int cur = 0;
	int sign = 1;
	for (char c : s) {
		if (is_digit(c)) {
			cur = cur * 10 + c - '0';
		} else {
			sum += cur * sign;
			cur = 0;
			sign = c == '-' ? -1 : 1;
		}
	}

	sum += cur * sign;

	ll ans = -INFL;

	for (int i = 0; i < szof(s); ++i) {
		if (s[i] == '+' || s[i] == '-') {
			int l = i - 1;
			while (l > 0 && is_digit(s[l - 1])) {
				--l;
			}
			int r = i + 1;
			while (r < szof(s) && is_digit(s[r])) {
				++r;
			}
			int num_before = stoi(s.substr(l, i - l));
			int cur_sign = 1;
			if (l && s[l - 1] == '-') {
				num_before *= -1;
				cur_sign = -1;
			}
			int num_after = stoi(s.substr(i + 1, r - i - 1));
			if (s[i] == '-') {
				num_after *= -1;
			}
			ll cur_sum = sum - num_before - num_after;
			ll cur_num = 0;
			for (int j = l; j < r; ++j) {
				if (is_digit(s[j])) {
					cur_num = cur_num * 10 + s[j] - '0';
				}
			}

			cur_sum += cur_sign * cur_num;
			ans = max(ans, cur_sum);
		} else {
			int l = i;
			while (l > 0 && is_digit(s[l - 1])) {
				--l;
			}
			int r = i;
			while (r < szof(s) && is_digit(s[r])) {
				++r;
			}
			int cur_sign = 1;
			if (l && s[l - 1] == '-') {
				cur_sign = -1;
			}
			ll cur_sum = sum - stoi(s.substr(l, r - l)) * cur_sign;
			int cur_num = 0;
			for (int j = l; j < r; ++j) {
				if (j != i) {
					cur_num = cur_num * 10 + s[j] - '0';
				}
			}
			cur_sum += cur_num * cur_sign;
			ans = max(ans, cur_sum);
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}

#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}