import java.io.*;
import java.util.HashMap;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author Sergey Melnikov
 */
public class good_subsegments_sm_tl2 {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        FastScanner in = new FastScanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        E solver = new E();
        solver.solve(1, in, out);
        out.close();
    }

    static class E {
        final int MAX_DELTA = 18;

        public void solve(int testNumber, FastScanner in, PrintWriter out) {
            int n = in.nextInt();
            int[] a = new int[n];
            int maxa = 0;
            for (int i = 0; i < a.length; i++) {
                a[i] = in.nextInt();
                maxa = Math.max(maxa, a[i]);
            }
//        int n = 50000;
//        int[] a = new int[n];
//        Arrays.fill(a, 1);
//        if (n <= 5000) {
//            out.println(solveN2logN(a));
//            return;
//        }
//        if (maxa <= 30) {
//            out.println(solveA30(n, a));
//            return;
//        }

            int ans = solve50k(a);
            int corr = solveN2logN(a);
            if (ans != corr) {
                throw new AssertionError(ans + " != " + corr);
            }
            out.println(ans);

        }

        private int solve50k(int[] a) {
            int ans = 0;
            for (int from = 0; from < a.length; from++) {
                long x = 0;
                int min = a[from];
                int max = a[from];
                int last = from;
                for (; last < a.length; last++) {
                    if (Math.max(a[last], max) - Math.min(a[last], min) > MAX_DELTA) {
                        break;
                    }
                    min = Math.min(min, a[last]);
                    max = Math.max(max, a[last]);
                }
//            System.err.println("min = " + min + ", max = " + max);
//            System.err.println(Arrays.toString(Arrays.copyOfRange(a, from, last)));
                for (int i = from; i < a.length; i++) {
                    if (a[i] - min > MAX_DELTA || a[i] < min) {
                        break;
                    }
                    x += 1 << (a[i] - min);
                    if ((x & (x - 1)) == 0) {
//                    System.err.println("i = " + i + ", x = " + Long.toBinaryString(x));
                        ans++;
                    }
                }
            }
            return ans;
        }

        private int solveN2logN(int[] a) {
            int ans = 0;
            for (int from = 0; from < a.length; from++) {
                HashMap<Integer, Integer> cnt = new HashMap<>();
//            System.err.println("from = " + from);
                for (int i = from; i < a.length; i++) {
                    int x = a[i];
//                System.err.println(" x = " + x + ", cnt = " + cnt);
                    while (cnt.containsKey(x)) {
                        int d = cnt.get(x) - 1;
                        if (d > 0) {
                            cnt.put(x, d);
                        } else {
                            cnt.remove(x);
                        }
                        x++;
                    }
                    cnt.put(x, cnt.getOrDefault(x, 0) + 1);
//                System.err.println(cnt);
                    if (cnt.size() == 1 && cnt.get(x) == 1) {
                        ans++;
                    }
                }
            }
            return ans;
        }

    }

    static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner(InputStream is) {
            this.br = new BufferedReader(new InputStreamReader(is));
        }

        public FastScanner(File f) {
            try {
                this.br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                throw new RuntimeException(e);
            }
        }

        public String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return st.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }
}

