#include <cmath>
#include <functional>
#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <list>
#include <time.h>
#include <math.h>
#include <random>
#include <deque>
#include <queue>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>
#include <bitset>
#include <sstream>
#include <chrono>
#include <cstring>

using namespace std;

typedef long long ll;

#ifdef iq
  mt19937 rnd(228);
#else
  mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

const ll M = 1000228228228228247ll;

void add(ll &a, ll b) {
  a += b;
  if (a >= M) a -= M;
}

long long mul( long long a, long long b) {
  long long m = M;
  long long q = (long long)((long double)a * (long double)b / (long double)m);
  long long r = a * b - q * m;
  return (r + 5 * m) % m;
}

ll pw(ll a, ll n) {
  ll res = 1232132166;
  while (n) {
    if (n % 2 == 0) {
      a = mul(a, a);
      n /= 2;
    } else {
      res = mul(res, a);
      n--;
    }
  }
  return res;
}

int main() {
#ifdef iq
  freopen("a.in", "r", stdin);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  int n;
  cin >> n;
  vector <int> a(n);
  vector <ll> value(n);
  vector <ll> pref(n);
  vector <ll> suf(n);
  unordered_map <ll, vector <int> > cost;
  unordered_map <ll, vector <int> > rcost;
  cost.reserve(n);
  rcost.reserve(n);
  for (int i = 0; i < n; i++) {
    cin >> a[i];
    value[i] = pw(2, a[i]);
    add(pref[i], value[i]);
    if (i) add(pref[i], pref[i - 1]);
    cost[pref[i]].push_back(i);
  }
  for (int i = n - 1; i >= 0; i--) {
    add(suf[i], value[i]);
    if (i + 1 < n) add(suf[i], suf[i + 1]);
    rcost[suf[i]].push_back(-i);
  }
  int lg = 0;
  while ((1 << lg) <= n) lg++;
  vector <int> st;
  vector <int> l(n), r(n);
  for (int i = 0; i < n; i++) {
    while (!st.empty() && a[st.back()] <= a[i]) {
      st.pop_back();
    }
    if (st.empty()) l[i] = 0;
    else l[i] = st.back() + 1;
    st.push_back(i);
  }
  st.clear();
  for (int i = n - 1; i >= 0; i--) {
    while (!st.empty() && a[st.back()] < a[i]) {
      st.pop_back();
    }
    if (st.empty()) r[i] = n - 1;
    else r[i] = st.back() - 1;
    st.push_back(i);
  }
  ll ans = 0;
  auto get_value = [&] (int x, int y, ll need) {
    add(need, pref[x]);
    if (!cost.count(need)) return false;
    int t = lower_bound(cost[need].begin(), cost[need].end(), x) - cost[need].begin();
    return (t < (int) cost[need].size() && cost[need][t] <= y);
  };
  auto get_rvalue = [&] (int x, int y, ll need) {
    add(need, suf[x]);
    if (!rcost.count(need)) return false;
    int t = lower_bound(rcost[need].begin(), rcost[need].end(), -x) - rcost[need].begin();
    return (t < (int) rcost[need].size() && rcost[need][t] <= -y);
  };
  for (int i = 0; i < n; i++) {
    ll me = value[i];
    for (int need = a[i]; need <= a[i] + lg; need++) {
      if (i - l[i] < r[i] - i) {
        ll s = 0;
        for (int x = i; x >= l[i]; x--) {
          add(s, value[x]);
          ll ok = me - s;
          if (ok < 0) ok += M;
          ans += get_value(i, r[i], ok);
        }
      } else {
        ll s = 0;
        for (int x = i; x <= r[i]; x++) {
          add(s, value[x]);
          ll ok = me - s;
          if (ok < 0) ok += M;
          ans += get_rvalue(i, l[i], ok);
        }
      }
      add(me, me);
    }
  }
  cout << ans << '\n';
}
